#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

#define FOR(A,B) for(int A=0; A < (int) (B);A++)
#define IMP 0

int n; //'n' is the size of each group
struct P {
	int p; //person
	int v; //value
};

P **M; 
//preference matrix of men
//M[i][j].p is the woman that man 'i' likes in the 'j'-th position, so
//M[i][0].p is the woman that man 'i' most like, and then M[i][M[i][0].p].v is the maximum 
//over all other values in M[i][*].v

P **W; //preference matrix of women

int *couple; //couple[i] is the woman that is married with man 'i'


//initialize matrices and global variables
void initialize() {
	M = (struct P**) malloc(sizeof(struct P*) * n);
	FOR(i,n) M[i] = (struct P*) malloc(sizeof(struct P)*n);

	W = (struct P**) malloc(sizeof(struct P*) * n);
	FOR(i,n) W[i] = (struct P*) malloc(sizeof(struct P)*n);

	couple = (int*) malloc(sizeof(int)*n);
	FOR(i,n) couple[i] = i;
}

//print
void imprime() {
	printf("\n");
	FOR(i,n) {
		printf("(%d,%d) " , i+1, couple[i]+1);
		if(i && !i%10) printf("\n");
	}
	printf("\n");
}

//return 1 if 'person' prefer 'p1' than 'p2', using his preference matrix 'm'
//return 0 otherwise
int isBetter(int person, int p1,int p2, struct P ** m) {
	return m[person][p1].v > m[person][p2].v;
}

//return 1 if 'casal' is a stable matching, else return 0
int check() {
	FOR(i,n)
		FOR(j,n) {
			if(i==j) continue;
			//we need to find a blocking pair
			//so we use it's definition
			//if man 'i' prefer the wife of man 'j' (couple[j])
			//and couple[j] prefer 'i' than 'j'.
			if(isBetter(i,couple[j],couple[i],M) && isBetter(couple[j],i,j,W)) {
				if(IMP) {
					printf("In the Matching\n");
					imprime();
					printf("we find the blocking pair (%d,%d)\n", i+1,couple[j]+1);
				}
				return 0;	
			}
		}
	return 1;
}

int main() {
	
	scanf("%d" , &n);
	initialize();

	FOR(i,n) FOR(j,n) {scanf("%d", &M[i][j].p);M[i][j].p--; M[i][M[i][j].p].v = n-j;}
	FOR(i,n) FOR(j,n) {scanf("%d", &W[i][j].p);W[i][j].p--; W[i][W[i][j].p].v = n-j;}

	int qtd = 0;

	//this loop will generate all possible marriages
	do {
		if(check()) { //and check if it is stable
			qtd++;
//			printf("Found a stable marriage!\n");
			imprime();	
		}
	} while(next_permutation(couple, couple+n));

//	printf("total number of possible stable marriages found = %d\n" , qtd);

    return 0;
}

