#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define FOR(A,B) for(int A=0; A < (int) (B);A++)
//#define DEBUG
#ifdef DEBUG
#define D(x) x
#else
#define D(x) 
#endif

int n; //tamanho de cada grupo
int **h; //matriz de preferencia dos homens, onde h[i][j] guarda a mulher de preferencia j, do homem i, 
//e a mulher de maior preferencia é guardada em h[i][0].
int **m; //matriz de preferencia das mulheres, idem. 
int *cnt; //cnt[i] guarda a posicao da proxima pessoa do sexo oposto ao qual a pessoa 'i' ira fazer a proposta
int *marido; //guarda com quem esta casada.
int *solteiro; //diz se a pessoa estah solteira ou nao. (0 ou 1)

int **val_h, **val_m;
int iteracao;
vector<int> fila;


void imprime() {
	D(printf("depois de %d iteracoes\n", iteracao);)
	D(printf("\nCASAIS (homem,mulher) - Proposta Masculina\n");)
	vector<pair<int,int> > vv;
	vv.clear();
	FOR(i,n) {
//		printf("(%d ,%d) " , marido[i]+1, i+1);
		vv.push_back(pair<int,int>(marido[i]+1,i+1));
//		if(i && !i%10) printf("\n");
	}
	sort(vv.begin(),vv.end());
	FOR(i,n) {
		printf("(%d ,%d) " , vv[i].first, vv[i].second);
		if(i && !i%10) printf("\n");
	}
	printf("\n");
}

//retorna 1 se 'homem_novo' tem preferencia maior que 'marido' na ordem de preferencia da mulher 'mulher'
//e basta ver o valor de cada homem guardado em val_m.
int melhor(int homem_novo, int marido, int mulher) {
	return val_m[mulher][homem_novo] > val_m[mulher][marido];
}

void atualiza_casal(int homem, int mulher) { 
	D(printf("homem %d faz proposta a mulher %d\n" , homem+1 , mulher+1);)

	if(marido[mulher] == -1) {
		marido[mulher] = homem;
		solteiro[homem] = 0;
		D(printf("agrupa casal %d %d\n", homem+1 , mulher+1);)
	}
	else if(melhor(homem , marido[mulher], mulher) ) {
		solteiro[marido[mulher]] = 1;
		fila.push_back(marido[mulher]);
		marido[mulher] = homem;
		solteiro[homem] = 0;
		D(printf("agrupa casal %d %d\n", homem+1 , mulher+1);)
	}
	else {
		solteiro[homem] = 1;
		fila.push_back(homem);
		D(printf("%d continua solteiro\n", homem+1);)
	}
}

//fazemos todas as propostas de pessoas que estavam solteiras ao inicio da chamada 
int homens_solteiros_fazem_proposta() {
	D(printf("Na iteracao %d :\n", iteracao));
	if(fila.empty()) return 0;
	int homem = fila.back();
	fila.pop_back();
	atualiza_casal(homem , h[homem][cnt[homem]++]);
	return 1;
}

//sei lah
void resolve() {
	while(homens_solteiros_fazem_proposta()) {
		iteracao++;
		D(imprime();)
	}
	imprime();
}

//inicializa matrizes e vetores globais
void inicializacao() {
	h = (int**) malloc(sizeof(int*) * n);
	FOR(i,n) h[i] = (int*) malloc(sizeof(int)*n);

	m = (int**) malloc(sizeof(int*) * n);
	FOR(i,n) m[i] = (int*) malloc(sizeof(int)*n);

	cnt = (int *) malloc(sizeof(int)*n);
	memset(cnt,0,sizeof(int)*n);

	marido = (int *) malloc(sizeof(int)*n);
	memset(marido,-1,sizeof(int)*n);

	solteiro = (int *) malloc(sizeof(int)*n);
	FOR(i,n) solteiro[i] = 1;

	val_h = (int**) malloc(sizeof(int*) * n);
	FOR(i,n) val_h[i] = (int*) malloc(sizeof(int)*n);

	val_m = (int**) malloc(sizeof(int*) * n);
	FOR(i,n) val_m[i] = (int*) malloc(sizeof(int)*n);

	fila.clear();
	FOR(i,n) fila.push_back(i);

	iteracao = 1;
}

void zera() {
	memset(cnt,0,sizeof(int)*n);
	memset(marido,-1,sizeof(int)*n);
	FOR(i,n) solteiro[i] = 1;
}

void leitura() {
	FOR(i,n) FOR(j,n) {
		scanf("%d", &h[i][j]);
		h[i][j]--;
		val_h[i][h[i][j]] = n-j;
	}
	FOR(i,n) FOR(j,n) {
		scanf("%d", &m[i][j]);
		m[i][j]--;
		val_m[i][m[i][j]] = n-j;
	}
}

int main() {
	scanf("%d" , &n);
	inicializacao();
	leitura();
	resolve();
    return 0;
}

